Vue ApexGantt

Installation

npm install vue-apexgantt apexgantt
# or
yarn add vue-apexgantt apexgantt
# or
pnpm add vue-apexgantt apexgantt

Demo

View Demo Project created using Vue-ApexGantt

License Setup

If you have a commercial license, set it once at app initialization before rendering any charts:

import { setApexGanttLicense } from 'vue-apexgantt';

// call this at the top of your app
setApexGanttLicense('your-license-key-here');

Example with Vue app entry point:

// main.ts
import { createApp } from 'vue';
import { setApexGanttLicense } from 'vue-apexgantt';
import App from './App.vue';

// set license before rendering
setApexGanttLicense('your-license-key-here');

createApp(App).mount('#app');

Quick Start

<template>
  <ApexGanttChart
    :tasks="tasks"
    :pixels-per-day="25.7"
    height="500px"
  />
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { ApexGanttChart } from 'vue-apexgantt';
import type { TaskInput } from 'vue-apexgantt';

const tasks = ref<TaskInput[]>([
  {
    id: 'task-1',
    name: 'Project Planning',
    startTime: '01-01-2024',
    endTime: '01-08-2024',
    progress: 75,
  },
  {
    id: 'task-2',
    name: 'Development',
    startTime: '01-09-2024',
    endTime: '01-20-2024',
    progress: 40,
    dependency: 'task-1',
  },
]);
</script>

API Reference

Component Props

PropTypeDefaultDescription
tasksTaskInput[]RequiredArray of tasks to display
optionsPartial<GanttUserOptions>ApexGantt configuration options
widthstring | number'100%'Chart width
heightstring | number'500px'Chart height
pixelsPerDaynumber4.9Timeline zoom in pixels-per-day; header tier auto-picks (0.5 year, 1.6 quarter, 4.9 month, 25.7 week, 80 day)
theme'light' | 'dark''light'Color theme
classNamestring''CSS class name
styleCSSPropertiesInline styles

Component Events

EventPayload TypeDescription
taskUpdateTaskUpdateEventDetailFired when a task is being updated
taskUpdateSuccessTaskUpdateSuccessEventDetailFired after successful task update
taskValidationErrorTaskValidationErrorEventDetailFired when validation fails
taskUpdateErrorTaskUpdateErrorEventDetailFired when update fails
taskDraggedTaskDraggedEventDetailFired when a task is dragged
taskResizedTaskResizedEventDetailFired when a task is resized

Event Handling Example

<template>
  <ApexGanttChart
    :tasks="tasks"
    @task-dragged="handleTaskDragged"
    @task-resized="handleTaskResized"
    @task-update-success="handleTaskUpdateSuccess"
  />
</template>

<script setup lang="ts">
import type { 
  TaskDraggedEventDetail,
  TaskResizedEventDetail,
  TaskUpdateSuccessEventDetail 
} from 'vue-apexgantt';

const handleTaskDragged = (detail: TaskDraggedEventDetail) => {
  console.log('Task dragged:', detail);
  // save to backend, etc.
};

const handleTaskResized = (detail: TaskResizedEventDetail) => {
  console.log('Task resized:', detail);
};

const handleTaskUpdateSuccess = (detail: TaskUpdateSuccessEventDetail) => {
  console.log('Task updated:', detail);
};
</script>

Template Ref Methods

Access chart methods using template ref:

<template>
  <ApexGanttChart
    ref="ganttRef"
    :tasks="tasks"
  />
  
  <button @click="handleZoomIn">Zoom In</button>
  <button @click="handleZoomOut">Zoom Out</button>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { ApexGanttChart } from 'vue-apexgantt';

const ganttRef = ref<InstanceType<typeof ApexGanttChart> | null>(null);

const handleZoomIn = () => {
  ganttRef.value?.zoomIn();
};

const handleZoomOut = () => {
  ganttRef.value?.zoomOut();
};

// available methods:
// ganttRef.value?.update(options)
// ganttRef.value?.updateTask(taskId, data)
// ganttRef.value?.zoomIn()
// ganttRef.value?.zoomOut()
// ganttRef.value?.destroy()
// ganttRef.value?.getInstance() // get raw ApexGantt instance
</script>

Composables

useGanttData

Parse external data into ApexGantt format:

<script setup lang="ts">
import { ref } from 'vue';
import { ApexGanttChart, useGanttData } from 'vue-apexgantt';
import type { ParsingConfig } from 'vue-apexgantt';

// raw API data
const apiData = ref([
  {
    task_id: 'T1',
    task_name: 'Design Phase',
    start_date: '01-01-2024',
    end_date: '01-15-2024',
    completion: 0.75,
  },
  // ...more tasks
]);

// parsing configuration
const parsingConfig: ParsingConfig = {
  id: 'task_id',
  name: 'task_name',
  startTime: 'start_date',
  endTime: 'end_date',
  progress: {
    key: 'completion',
    transform: (value) => value * 100, // convert to percentage
  },
};

// parse data
const tasks = useGanttData({
  data: apiData,
  parsing: parsingConfig,
});
</script>

<template>
  <ApexGanttChart :tasks="tasks" />
</template>

Nested Objects & Transforms

Use dot notation for nested properties:

const nestedData = ref([
  {
    project: {
      task: { id: 'T1', title: 'Design' },
      dates: { start: '01-01-2024', end: '01-15-2024' },
      status: { completion: 0.75 },
    },
  },
]);

const tasks = useGanttData({
  data: nestedData,
  parsing: {
    id: 'project.task.id',
    name: 'project.task.title',
    startTime: 'project.dates.start',
    endTime: 'project.dates.end',
    progress: {
      key: 'project.status.completion',
      transform: (value) => value * 100,
    },
  },
});

Advanced Usage

Custom Options

<template>
  <ApexGanttChart
    :tasks="tasks"
    :options="ganttOptions"
    :pixels-per-day="25.7"
    theme="dark"
  />
</template>

<script setup lang="ts">
import type { GanttUserOptions } from 'vue-apexgantt';

const ganttOptions: Partial<GanttUserOptions> = {
  enableTaskDrag: true,
  enableTaskResize: true,
  enableTaskEdit: true,
  barBackgroundColor: '#537CFA',
  rowBackgroundColors: ['#FFFFFF', '#F8F9FA'],
  // ...more options
};
</script>

Dynamic Zoom

<template>
  <div>
    <select v-model.number="pixelsPerDay">
      <option :value="80">Day</option>
      <option :value="25.7">Week</option>
      <option :value="4.9">Month</option>
      <option :value="1.6">Quarter</option>
      <option :value="0.5">Year</option>
    </select>
    
    <ApexGanttChart
      :tasks="tasks"
      :pixels-per-day="pixelsPerDay"
    />
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';

const pixelsPerDay = ref(4.9);
</script>

Theme Switching

<template>
  <div>
    <button @click="toggleTheme">
      {{ theme === 'light' ? '? Dark' : '☀️ Light' }}
    </button>
    
    <ApexGanttChart
      :tasks="tasks"
      :theme="theme"
    />
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import type { ThemeMode } from 'vue-apexgantt';

const theme = ref<ThemeMode>('light');

const toggleTheme = () => {
  theme.value = theme.value === 'light' ? 'dark' : 'light';
};
</script>

Column Configuration

Customize the task list columns with columnConfig inside the options prop:

<template>
  <ApexGanttChart :tasks="tasks" :options="ganttOptions" height="500px" />
</template>

<script setup lang="ts">
import type { GanttUserOptions } from 'vue-apexgantt';

const ganttOptions: Partial<GanttUserOptions> = {
  columnConfig: [
    { key: 'name',      title: 'Task Name', minWidth: '160px', flexGrow: 3 },
    { key: 'startTime', title: 'Start',     minWidth: '100px', flexGrow: 1 },
    { key: 'endTime',   title: 'End',       minWidth: '100px', flexGrow: 1 },
    { key: 'progress',  title: 'Progress',  minWidth: '80px',  flexGrow: 1 },
  ],
};
</script>

Annotations

Highlight specific dates or date ranges with visual annotations:

<template>
  <ApexGanttChart :tasks="tasks" :options="ganttOptions" height="500px" />
</template>

<script setup lang="ts">
import type { GanttUserOptions } from 'vue-apexgantt';

const ganttOptions: Partial<GanttUserOptions> = {
  annotations: [
    {
      x1: '2024-03-15',
      x2: '2024-03-31',
      label: {
        text: 'Sprint 1',
        fontColor: '#333333',
      },
    },
    {
      x1: '2024-04-01',
      label: {
        text: 'Go Live',
        fontColor: '#008FFB',
      },
    },
  ],
};
</script>

TypeScript Support

The package includes full TypeScript definitions. Import types as needed:

import type {
  TaskInput,
  TaskType,
  ThemeMode,
  GanttUserOptions,
  ParsingConfig,
  TaskUpdateEventDetail,
  TaskDraggedEventDetail,
  TaskResizedEventDetail,
  // ...more types
} from 'vue-apexgantt';

Angular ApexGantt

Installation

npm install ngx-apexgantt apexgantt
# or
yarn add ngx-apexgantt apexgantt

Demo

View Demo Project created using ngx-apexgantt

License Setup

If you have a commercial license, set it once at app initialization before rendering any charts.

Option 1: Angular Provider (Recommended)

Standalone App:

// app.config.ts
import { ApplicationConfig } from "@angular/core";
import { provideApexGanttLicense } from "ngx-apexgantt";

export const appConfig: ApplicationConfig = {
  providers: [
    provideApexGanttLicense("your-license-key-here"),
    // other providers...
  ],
};

Module-based App:

// app.module.ts
import { NgModule } from "@angular/core";
import { provideApexGanttLicense } from "ngx-apexgantt";

@NgModule({
  providers: [provideApexGanttLicense("your-license-key-here")],
})
export class AppModule {}

Option 2: Static Method

// main.ts
import { bootstrapApplication } from "@angular/platform-browser";
import { setApexGanttLicense } from "ngx-apexgantt";
import { AppComponent } from "./app/app.component";
import { appConfig } from "./app/app.config";

// set license before bootstrapping
setApexGanttLicense("your-license-key-here");

bootstrapApplication(AppComponent, appConfig);

Quick Start

Standalone Component

import { Component } from "@angular/core";
import { NgxApexGanttComponent, TaskInput } from "ngx-apexgantt";

@Component({
  selector: "app-root",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `
    <ngx-apexgantt
      ="tasks"
      [pixelsPerDay]="25.7"
      ="'500px'"
      (taskUpdateSuccess)="onTaskUpdate($event)"
    >
    </ngx-apexgantt>
  `,
})
export class AppComponent {
  tasks: TaskInput[] = [
    {
      id: "task-1",
      name: "Project Planning",
      startTime: "01-01-2024",
      endTime: "01-08-2024",
      progress: 75,
    },
    {
      id: "task-2",
      name: "Development",
      startTime: "01-09-2024",
      endTime: "01-20-2024",
      progress: 40,
      dependency: "task-1",
    },
  ];

  onTaskUpdate(event: any) {
    console.log("Task updated:", event);
  }
}

Module-based Component

import { Component } from "@angular/core";
import { TaskInput } from "ngx-apexgantt";

@Component({
  selector: "app-gantt",
  template: `
    <ngx-apexgantt ="tasks" [pixelsPerDay]="25.7" ="'500px'">
    </ngx-apexgantt>
  `,
})
export class GanttComponent {
  tasks: TaskInput[] = [
    // your tasks...
  ];
}
// app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { NgxApexGanttModule } from "ngx-apexgantt";
import { GanttComponent } from "./gantt.component";

@NgModule({
  declarations: [GanttComponent],
  imports: [BrowserModule, NgxApexGanttModule],
})
export class AppModule {}

Component API

Inputs

Primary Configuration

InputTypeDescription
optionsGanttOptionsComplete ApexGantt configuration object

Shortcut Inputs (Optional - Override options)

InputTypeDescription
tasksTaskInput[]Array of tasks (shortcut for options.series)
pixelsPerDaynumberTimeline zoom in pixels-per-day; header tier auto-picks (0.5 year, 1.6 quarter, 4.9 month, 25.7 week, 80 day). Omit to auto-fit.
theme'light' | 'dark'Color theme
widthstring | numberChart width
heightstring | numberChart height

Styling Inputs

InputTypeDescription
classNamestringCSS class name
stylesRecord<string, any>Inline styles

Outputs (Events)

OutputTypeDescription
taskUpdateEventEmitterFired when a task is being updated
taskUpdateSuccessEventEmitterFired after successful task update
taskValidationErrorEventEmitterFired when form validation fails
taskUpdateErrorEventEmitterFired when update fails
taskDraggedEventEmitterFired when a task is dragged
taskResizedEventEmitterFired when a task is resized

Public Methods

Access these methods using @ViewChild:

import { Component, ViewChild } from "@angular/core";
import { NgxApexGanttComponent } from "ngx-apexgantt";

@Component({
  template: `<ngx-apexgantt #ganttChart></ngx-apexgantt>`,
})
export class MyComponent {
  @ViewChild("ganttChart") ganttChart!: NgxApexGanttComponent;

  zoomIn() {
    this.ganttChart.zoomIn();
  }

  zoomOut() {
    this.ganttChart.zoomOut();
  }

  updateTask() {
    this.ganttChart.updateTask("task-1", { progress: 80 });
  }

  updateAll() {
    this.ganttChart.update({ pixelsPerDay: 4.9 });
  }
}
MethodParametersDescription
updateoptions: GanttOptionsUpdate entire gantt configuration
updateTasktaskId: string, taskData: Partial<TaskInput>Update a specific task
zoomInnoneZoom in the gantt chart
zoomOutnoneZoom out the gantt chart
getGanttInstancenoneGet underlying ApexGantt instance

Usage Examples

Basic Example with Zoom Controls

import { Component, ViewChild } from "@angular/core";
import { NgxApexGanttComponent, TaskInput } from "ngx-apexgantt";

@Component({
  selector: "app-gantt-basic",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `
    <div class="controls">
      <button (click)="ganttChart.zoomIn()">Zoom In</button>
      <button (click)="ganttChart.zoomOut()">Zoom Out</button>
    </div>
    <ngx-apexgantt
      #ganttChart
      ="tasks"
      [pixelsPerDay]="25.7"
      ="'500px'"
    >
    </ngx-apexgantt>
  `,
})
export class GanttBasicComponent {
  @ViewChild("ganttChart") ganttChart!: NgxApexGanttComponent;

  tasks: TaskInput[] = [
    {
      id: "task-1",
      name: "Planning",
      startTime: "01-01-2024",
      endTime: "01-10-2024",
      progress: 100,
    },
    {
      id: "task-2",
      name: "Development",
      startTime: "01-11-2024",
      endTime: "01-25-2024",
      progress: 60,
      dependency: "task-1",
    },
  ];
}

Advanced Example with Full Options

import { Component } from "@angular/core";
import { NgxApexGanttComponent, GanttOptions } from "ngx-apexgantt";

@Component({
  selector: "app-gantt-advanced",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `
    <div class="controls">
      <select [(ngModel)]="currentPixelsPerDay" (change)="updatePixelsPerDay()">
        <option [value]="80">Day</option>
        <option [value]="25.7">Week</option>
        <option [value]="4.9">Month</option>
      </select>
      <button (click)="toggleTheme()">Toggle Theme</button>
    </div>
    <ngx-apexgantt
      ="ganttOptions"
      [pixelsPerDay]="currentPixelsPerDay"
      ="currentTheme"
      (taskUpdateSuccess)="onTaskUpdate($event)"
      (taskDragged)="onTaskDragged($event)"
    >
    </ngx-apexgantt>
  `,
})
export class GanttAdvancedComponent {
  currentPixelsPerDay = 25.7;
  currentTheme: "light" | "dark" = "light";

  ganttOptions: GanttOptions = {
    series: [
      {
        id: "task-1",
        name: "Design Phase",
        startTime: "01-01-2024",
        endTime: "01-15-2024",
        progress: 75,
      },
      // more tasks...
    ],
    height: "600px",
    enableToolbar: true,
    enableTaskDrag: true,
    enableTaskResize: true,
    barBackgroundColor: "#537CFA",
    rowHeight: 32,
  };

  updatePixelsPerDay() {
    console.log("Zoom changed to pixelsPerDay:", this.currentPixelsPerDay);
  }

  toggleTheme() {
    this.currentTheme = this.currentTheme === "light" ? "dark" : "light";
  }

  onTaskUpdate(event: any) {
    console.log("Task updated:", event);
    // save to backend
  }

  onTaskDragged(event: any) {
    console.log("Task dragged:", event);
  }
}

Data Parsing Example

import { Component } from "@angular/core";
import { NgxApexGanttComponent, GanttOptions } from "ngx-apexgantt";

@Component({
  selector: "app-gantt-parsing",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `<ngx-apexgantt ="ganttOptions"></ngx-apexgantt>`,
})
export class GanttParsingComponent {
  // external data format from API
  apiData = [
    {
      task_id: "T1",
      task_name: "Design Phase",
      start_date: "01-01-2024",
      end_date: "01-15-2024",
      completion: 75,
    },
    {
      task_id: "T2",
      task_name: "Development",
      start_date: "01-16-2024",
      end_date: "01-30-2024",
      completion: 40,
    },
  ];

  ganttOptions: GanttOptions = {
    series: this.apiData,
    parsing: {
      id: "task_id",
      name: "task_name",
      startTime: "start_date",
      endTime: "end_date",
      progress: "completion",
    },
    height: "500px",
  };
}

Event Handling Example

import { Component } from "@angular/core";
import { NgxApexGanttComponent } from "ngx-apexgantt";

@Component({
  selector: "app-gantt-events",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `
    <ngx-apexgantt
      ="tasks"
      (taskUpdateSuccess)="handleTaskUpdate($event)"
      (taskDragged)="handleTaskDragged($event)"
      (taskResized)="handleTaskResized($event)"
      (taskUpdateError)="handleError($event)"
    >
    </ngx-apexgantt>
    <div class="event-log">
      <h3>Event Log:</h3>
      <pre>{{ eventLog }}</pre>
    </div>
  `,
})
export class GanttEventsComponent {
  tasks = [
    // your tasks...
  ];

  eventLog = "";

  handleTaskUpdate(event: any) {
    this.eventLog += `Task Updated: ${event.taskId}\n`;
    // sync with backend
    this.syncWithBackend(event.updatedTask);
  }

  handleTaskDragged(event: any) {
    this.eventLog += `Task Dragged: ${event.taskId} moved ${event.daysMoved} days\n`;
  }

  handleTaskResized(event: any) {
    this.eventLog += `Task Resized: ${event.taskId} duration changed by ${event.durationChange}\n`;
  }

  handleError(event: any) {
    console.error("Update failed:", event.error);
  }

  async syncWithBackend(task: any) {
    // your API call here
  }
}

Column Configuration

Customize task table column widths:

import { ColumnKey } from "ngx-apexgantt";

ganttOptions: GanttOptions = {
  series: tasks,
  columnConfig: [
    {
      key: ColumnKey.Name,
      title: "Task Name",
      minWidth: "100px",
      flexGrow: 3,
    },
    {
      key: ColumnKey.StartTime,
      title: "Start",
      minWidth: "100px",
      flexGrow: 1.5,
    },
    {
      key: ColumnKey.Duration,
      title: "Duration",
      minWidth: "80px",
      flexGrow: 1,
    },
  ],
};

Annotations

Add visual annotations to highlight specific dates or date ranges:

ganttOptions: GanttOptions = {
  series: tasks,
  annotations: [
    {
      x1: "10-25-2024",
      x2: "END_DATE",
      label: {
        text: "Sprint 1",
        fontColor: "#333333",
      },
    },
  ],
};

TypeScript Support

The library is fully typed. Import types as needed:

import {
  NgxApexGanttComponent,
  GanttOptions,
  TaskInput,
  ColumnKey,
  TaskUpdateDetail,
  TaskDraggedDetail,
} from "ngx-apexgantt";

React ApexGantt

Installation

npm install react-apexgantt apexgantt

View Demo Project

License Setup

Call setApexGanttLicense once at app startup, before any component renders. The best place is your entry file:

// main.tsx
import React from "react"
import ReactDOM from "react-dom/client"
import { setApexGanttLicense } from "react-apexgantt"
import App from "./App"

setApexGanttLicense("your-license-key-here")

ReactDOM.createRoot(document.getElementById("root")!).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>
)

Quick Start

import { ApexGanttChart } from "react-apexgantt"
import type { TaskInput } from "react-apexgantt"

const tasks: TaskInput[] = [
  {
    id: "phase-1",
    name: "Phase 1: Research",
    startTime: "2024-03-01",
    endTime: "2024-03-15",
    progress: 100,
  },
  {
    id: "task-1",
    name: "User interviews",
    startTime: "2024-03-01",
    endTime: "2024-03-08",
    parentId: "phase-1",
    progress: 100,
  },
  {
    id: "task-2",
    name: "Competitive analysis",
    startTime: "2024-03-06",
    endTime: "2024-03-15",
    parentId: "phase-1",
    progress: 80,
  },
  {
    id: "phase-2",
    name: "Phase 2: Design",
    startTime: "2024-03-16",
    endTime: "2024-04-05",
    progress: 30,
    dependency: "phase-1",
  },
]

export default function App() {
  return <ApexGanttChart tasks={tasks} pixelsPerDay={25.7} height="500px" />
}

parentId links a task to its parent row to form a hierarchy. dependency draws an arrow between tasks and represents a finish-to-start dependency.

Props

PropTypeDescription
tasksTaskInput[]Array of tasks to render
optionsOmit<GanttUserOptions, 'series'>Full chart configuration (excludes series, which is derived from tasks)
widthstring | numberChart width — overrides options.width
heightstring | numberChart height — overrides options.height
pixelsPerDaynumberTimeline zoom, in pixels-per-day. The header tier is auto-picked (reference points: 0.5 year, 1.6 quarter, 4.9 month, 25.7 week, 80 day). Omit to auto-fit the data span.
theme'light' | 'dark'Color theme
classNamestringCSS class on the wrapper <div>
styleCSSPropertiesInline styles on the wrapper <div>

Events

All event callbacks receive a typed detail object. The component stores handlers in a ref internally, so changing the callback on re-render does not require wrapping it in useCallback.

PropFires when
onTaskUpdateA task edit is in progress (before completion)
onTaskUpdateSuccessA task update commits successfully
onTaskUpdateErrorA task update fails
onTaskValidationErrorTask form validation fails
onTaskDraggedA task bar is dragged to a new date
onTaskResizedA task bar is resized via its handles
onSelectionChangeThe set of selected tasks changes
onDependencyArrowUpdateA dependency arrow is created, moved, or deleted
import { ApexGanttChart } from "react-apexgantt"

export default function GanttWithEvents() {
  return (
    <ApexGanttChart
      tasks={tasks}
      height="500px"
      onTaskUpdateSuccess={(detail) => {
        console.log("Task updated:", detail)
        // save to your backend
      }}
      onTaskDragged={(detail) => {
        console.log("Task dragged:", detail)
      }}
      onTaskUpdateError={(detail) => {
        console.error("Update failed:", detail.error)
      }}
    />
  )
}

Imperative API via ref

Use useRef<ApexGanttHandle> to call chart methods programmatically after mount.

import { useRef } from "react"
import { ApexGanttChart } from "react-apexgantt"
import type { ApexGanttHandle } from "react-apexgantt"

export default function GanttWithControls() {
  const ganttRef = useRef<ApexGanttHandle>(null)

  return (
    <div>
      <div style={{ marginBottom: 12, display: "flex", gap: 8 }}>
        <button onClick={() => ganttRef.current?.zoomIn()}>Zoom In</button>
        <button onClick={() => ganttRef.current?.zoomOut()}>Zoom Out</button>
        <button onClick={() => {
          ganttRef.current?.updateTask("task-1", { progress: 100 })
        }}>
          Mark task-1 done
        </button>
      </div>
      <ApexGanttChart ref={ganttRef} tasks={tasks} height="500px" />
    </div>
  )
}

Available methods on ApexGanttHandle:

MethodDescription
update(options)Replace the full chart configuration
updateTask(taskId, data)Update a single task by ID with partial fields
zoomIn()Zoom in one time-scale level
zoomOut()Zoom out one time-scale level
destroy()Destroy the chart and clean up DOM and listeners
getInstance()Return the underlying raw ApexGantt instance

Dynamic zoom and theme

Bind pixelsPerDay and theme to React state. The component diffs props on every render and calls update() internally only when something changes.

import { useState } from "react"
import { ApexGanttChart } from "react-apexgantt"

export default function DynamicGantt() {
  const [pixelsPerDay, setPixelsPerDay] = useState(25.7)
  const [theme, setTheme] = useState<"light" | "dark">("light")

  return (
    <div>
      <div style={{ marginBottom: 12, display: "flex", gap: 12 }}>
        <label>
          Zoom:
          <select
            value={pixelsPerDay}
            onChange={(e) => setPixelsPerDay(Number(e.target.value))}
          >
            <option value={80}>Day</option>
            <option value={25.7}>Week</option>
            <option value={4.9}>Month</option>
            <option value={1.6}>Quarter</option>
            <option value={0.5}>Year</option>
          </select>
        </label>
        <button onClick={() => setTheme(t => t === "light" ? "dark" : "light")}>
          Toggle theme
        </button>
      </div>
      <ApexGanttChart
        tasks={tasks}
        pixelsPerDay={pixelsPerDay}
        theme={theme}
        height="500px"
      />
    </div>
  )
}

Options

Pass any configuration from the options reference via the options prop. The series key is omitted — it is always derived from tasks.

import type { GanttUserOptions } from "react-apexgantt"

const options: Omit<GanttUserOptions, "series"> = {
  enableTaskDrag: true,
  enableTaskResize: true,
  enableTaskEdit: true,
  enableInlineEdit: true,
  barBackgroundColor: "#537CFA",
  rowHeight: 36,
  columnConfig: [
    { key: "name",      title: "Task",     minWidth: "160px", flexGrow: 3 },
    { key: "startTime", title: "Start",    minWidth: "100px", flexGrow: 1 },
    { key: "endTime",   title: "End",      minWidth: "100px", flexGrow: 1 },
    { key: "progress",  title: "Progress", minWidth: "80px",  flexGrow: 1 },
  ],
}

export default function ConfiguredGantt() {
  return <ApexGanttChart tasks={tasks} options={options} height="600px" />
}

useGanttData — parsing external data

When your API returns data in a different shape, useGanttData maps and memoizes it into the TaskInput[] format ApexGantt expects. It only re-parses when data or parsing changes.

import { useGanttData, ApexGanttChart } from "react-apexgantt"

const rawApiData = [
  {
    task_id: "T1",
    task_name: "Planning Phase",
    start: "2024-01-01",
    end: "2024-01-10",
    completion: 100,
  },
  {
    task_id: "T2",
    task_name: "Development",
    start: "2024-01-11",
    end: "2024-01-25",
    completion: 60,
    depends_on: "T1",
  },
  {
    task_id: "T3",
    task_name: "Frontend",
    start: "2024-01-11",
    end: "2024-01-18",
    completion: 80,
    parent_task: "T2",
  },
]

const parsingConfig = {
  id: "task_id",
  name: "task_name",
  startTime: "start",
  endTime: "end",
  progress: "completion",
  dependency: "depends_on",
  parentId: "parent_task",
}

export default function ParsedGantt() {
  const tasks = useGanttData({ data: rawApiData, parsing: parsingConfig })
  return <ApexGanttChart tasks={tasks} height="500px" />
}

For nested objects, use dot-notation paths. For values that need transformation, pass an object with key and transform:

const parsingConfig = {
  id: "project.task.id",
  name: "project.task.title",
  startTime: "project.dates.start",
  endTime: "project.dates.end",
  progress: {
    key: "project.status.completion",
    transform: (value: number) => value * 100, // convert 0-1 to 0-100
  },
}

useGanttEvents — memoized event handlers

When you need stable event handler references (for example, inside useCallback or when passing to child components), use useGanttEvents:

import { useGanttEvents, ApexGanttChart } from "react-apexgantt"

export default function GanttWithMemoizedEvents() {
  const { handleTaskUpdate, handleTaskDragged, handleTaskResized } =
    useGanttEvents({
      onTaskUpdate: (detail) => console.log("updating:", detail),
      onTaskDragged: (detail) => console.log("dragged:", detail),
      onTaskResized: (detail) => console.log("resized:", detail),
    })

  return (
    <ApexGanttChart
      tasks={tasks}
      height="500px"
      onTaskUpdate={handleTaskUpdate}
      onTaskDragged={handleTaskDragged}
      onTaskResized={handleTaskResized}
    />
  )
}

TypeScript

All types are exported from react-apexgantt:

import type {
  TaskInput,
  ThemeMode,
  GanttUserOptions,
  ApexGanttHandle,
  ApexGanttChartProps,
} from "react-apexgantt"

For event detail types, import from the underlying apexgantt package:

import type { GanttEventMap } from "apexgantt"

type TaskUpdateDetail = GanttEventMap["taskUpdateSuccess"]["detail"]